﻿$.extend(vtb.maps, {
	icon: {
		iconOffset: [-12, -36],
		iconSmall: [35, 33],

		//На всякий случай, сохранил прокидывание размеров. Вдруг размеры иконок потом всё-таки будут отличаться
		getMapIcon: function (item) {
			with (vtb.maps) {
				switch (item.Type) {
					case posTypes.office:
					default:
						return {
							iconImageSize: icon.iconSmall,
							iconImageHref: $.Enumerable.From(vtb.maps.icons.PosIcons)
								.Where(function (i) {
									return (i.MapObjectType == vtb.maps.posTypes.office);
								}).First().IconMap
						};

					case posTypes.atm:
						return {
							iconImageSize: icon.iconSmall,
							iconImageHref: $.Enumerable.From(vtb.maps.icons.PosIcons)
								.Where(function (i) {
									return ((i.MapObjectType == vtb.maps.posTypes.atm) && (i.IsSelfOwned == item.IsSelfOwned));
								}).First().IconMap
						};

					case posTypes.terminal:
						return {
							iconImageSize: icon.iconSmall,
							iconImageHref: $.Enumerable.From(vtb.maps.icons.PosIcons)
								.Where(function (i) {
									return ((i.MapObjectType == vtb.maps.posTypes.terminal) && (i.IsSelfOwned == item.IsSelfOwned));
								}).First().IconMap
						};

					case posTypes.stand:
						return {
							iconImageSize: icon.iconSmall,
							iconImageHref: $.Enumerable.From(vtb.maps.icons.PosIcons)
								.Where(function (i) {
									return (i.MapObjectType == vtb.maps.posTypes.stand);
								}).First().IconMap
						};
					    
				    case posTypes.partner:
				        return {
				            iconImageSize: icon.iconSmall,
				            iconImageHref: $.Enumerable.From(vtb.maps.icons.PosIcons)
								.Where(function (i) {
								    return (i.MapObjectType == vtb.maps.posTypes.partner);
								}).First().IconMap
				        };
				}
			}
		},

		getBalloonIcon: function (item) {
			with (vtb.maps) {
				switch (item.Type) {
					case posTypes.office:
					default:
						return $.Enumerable.From(vtb.maps.icons.PosIcons)
							.Where(function (i) {
								return (i.MapObjectType == vtb.maps.posTypes.office);
							}).First().IconBalloon;

					case posTypes.atm:
						return $.Enumerable.From(vtb.maps.icons.PosIcons)
							.Where(function (i) {
								return ((i.MapObjectType == vtb.maps.posTypes.atm) && (i.IsSelfOwned == item.IsSelfOwned));
							}).First().IconBalloon;

					case posTypes.terminal:
						return $.Enumerable.From(vtb.maps.icons.PosIcons)
							.Where(function (i) {
								return ((i.MapObjectType == vtb.maps.posTypes.terminal) && (i.IsSelfOwned == item.IsSelfOwned));
							}).First().IconBalloon;

					case posTypes.stand:
						return $.Enumerable.From(vtb.maps.icons.PosIcons)
							.Where(function (i) {
								return (i.MapObjectType == vtb.maps.posTypes.stand);
							}).First().IconBalloon;
					    
				    case posTypes.partner:
				        return $.Enumerable.From(vtb.maps.icons.PosIcons)
							.Where(function (i) {
							    return (i.MapObjectType == vtb.maps.posTypes.partner);
							}).First().IconBalloon;
				}
			}
		}
	},

	cluster: {
		iconHref: null,
		clusterIcons: null,
		clusterNumbers: [100],
		clusterer: null,

		initIcon: function () {
			with (vtb.maps) {
				var tabName = location.hash.substr(1);
				if (tabName == '')
					tabName = tabs.original.offices;

				cluster.iconHref = $.Enumerable.From(vtb.maps.icons.ClusterIcons)
					.Where(function (i) {
						return (i.MapAlias == tabName);
					}).First().ClusterIcon;

				cluster.clusterIcons = [{
					href: cluster.iconHref,
					size: [40, 40],
					offset: [-20, -20]
				}, {
					href: cluster.iconHref,
					size: [60, 60],
					offset: [-20, -20]
				}];
			}
		}
	}
});